#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define WRITE(tt) printf("%c\n", tt)
#define WRITE1(tt) printf("%d\n", tt)

struct tlist {
	void *data;
	struct tlist *next, *prev;
};

typedef struct tlist *list;

struct stack {
	list head, tail;
};

struct stack st, se, sp;

/*Add to stack------------------------------------------------------*/  

struct stack push(struct stack s, void *x)
{
	list p = malloc(sizeof(*p));
	
	p->data = x;
	
	if ((s.head == NULL) && (s.tail == NULL)) {
		s.tail = p;
		s.head = p;
		p->next = NULL;
		p->prev = NULL;
	} else {
		p->prev = NULL;
		p->next = s.head;
		s.head->prev = p;
		s.head = p;
	}
	
	return s;
}

/*Get out of the stack------------------------------------------------*/

void *pop(struct stack s)
{
	list p = s.head;
	void *x;
	
	if (!p) return 0;
	x = p->data;
	
	s.head = s.head->next;
	
	if (s.head) s.head->prev = NULL;
	else s.tail = NULL;
	
	return x;
}

/*void orderT(struct stack s)
{
	list p = malloc(sizeof(*p));
	p = s.head;
	while (p != NULL) {
		printf("%c\n", p->data);
		p = p->next;
	}
}

void orderE(struct stack s)
{
	list p = malloc(sizeof(*p));
	p = s.head;
	while (p != NULL) {
		printf("%d\n", p->data);
		p = p->next;
	}
}

void orderback(struct stack s)
{
	list p = malloc(sizeof(*p));
	p = s.tail;
	while (p != NULL) {
		printf("%c\n", p->data);
		p = p->prev;
	}
}

struct stack strcopy(struct stack s, char *str)
{
	int i = 0;
	while (str[i] != '\0') {
		s = push(s, str[i]);
		i++;
	}
	return s;
}*/

/*Remove from the stack--------------------------------------*/

struct stack del(struct stack s)
{
	s.head = s.head->next;
	
	return s;
}

int operation(int x, int y, char c)
{
	switch (c) {
		case '+': return x + y; break;
		case '-': return x - y; break;
		case '*': return x * y; break;
		case '/': return x / y; break;
		case '%': return x % y; break;
	}
}

/* Для разбора строки я использовал алгоритм Бауэра - Замельзона (http://algolist.manual.ru/syntax/parsear.php).
 Это работает только с однозначными цифрами, также нет обработки двойных операторов типа ++.*/

void proga()
{
	char *s2 = (char *) malloc(81); 
	gets(s2);
	
	char *s = (char *) malloc(81);
	
	s = strcat(s2, "$");
	int n = strlen(s);
	
	int ERR = 0;
	int c;
	void *x; 
	
	int i = 0; 
	
	while (s[i] != '\0') {
		switch(s[i]) {
		
		case '$': 
			x = pop(st);
			
			if ((x == 0)) {
				i = n;
				break;
			} else if (x == '(') {
				ERR = 1;
			
				i = n;
				break;
			} else {
				c = operation(se.head->next->data, se.head->data, x);
				se = del(se);
				se.head->data = c; 
				
				st = del(st);
				break;
			}
		case '(':
			st = push(st, s[i]);
		
			i++;
			break;
		case '-':
		case '+': 
			if (i == 0) se = push(se, 0);
		
			x = pop(st);
		
			if ((x == 0) || (x == '(')) {
				st = push(st, s[i]);
			
				i++;
				break;
			} else if ((x == '+') || (x == '-')) {
				c = operation(se.head->next->data, se.head->data, x);
				se = del(se);
				se.head->data = c; 
			
				st.head->data = s[i];
			
				i++;
				break;
			} else {
				c = operation(se.head->next->data, se.head->data, x);
				se = del(se); 
				se.head->data = c;
					st.head->data = s[i];
			
				i++;
				break;
			}
		case '/':
		case '*': 
			if (i == 0) {
				ERR = 1;
			
				i = n;
				break;
			}
		
			x = pop(st);
					
			if ((x == '*') || (x == '/') || (x == '%')) {
				c = operation(se.head->next->data, se.head->data, x);
				se = del(se);
				se.head->data = c; 
			
				st.head->data = s[i];
			
				i++;
				break;
			} else {
				if (x == 0) st = sp;
				st = push(st, s[i]);
			
				i++;
				break;
			}
		case ')':
			x = pop(st);
		
			if ((x == 0)) {
				ERR = 1;
			
				i = n;
				break;
			} else if (x == '(') {
				st = del(st);
			
				i++;
				break;
			} else {
			
				c = operation(se.head->next->data, se.head->data, x);
				se = del(se);
			
				se.head->data = c;
			
				st = del(st);
			
				break;
			}
		default:
			if ((s[i] == '0') || (s[i] == '1') || (s[i] == '2') || 
			    (s[i] == '3') || (s[i] == '4') || (s[i] == '5') || 
			    (s[i] == '6') || (s[i] == '7') || (s[i] == '8') || (s[i] == '9')) {
				se = push(se, s[i] - '0');
				i++;
				break;
			} else {
				i++;
				break;
			}
		}
	}
	
	if ( ERR == 0) {
		WRITE1(pop(se)); 
	} else printf("ERROR\n");
}


/*---------------------------------------------------------------------------------------------------------------*/

int main(int argc, char *argv[]) 
{
	proga();
	
	return EXIT_SUCCESS;
}

/* Не судите строго. Если это совсем не то, тогда подскажите что-нибудь.*/